---
title: Generator
slug: Web/JavaScript/Reference/Global_Objects/Generator
tags:
  - Class
  - ECMAScript 2015
  - Generator
  - JavaScript
  - Legacy Generator
  - Legacy Iterator
  - Reference
---
<div>{{JSRef}}</div>

<p>The <code><strong>Generator</strong></code> object is returned by a {{JSxRef("Statements/function*", "generator function", "", 1)}} and it conforms to both the <a href="/en-US/docs/Web/JavaScript/Reference/Iteration_protocols#The_iterable_protocol">iterable protocol</a> and the <a href="/en-US/docs/Web/JavaScript/Reference/Iteration_protocols#The_iterator_protocol">iterator protocol</a>.</p>

<h2 id="Constructor">Constructor</h2>

<p>This object cannot be instantiated directly. Instead, a <code>Generator</code> instance can be returned from a <a href="/en-US/docs/Web/JavaScript/Reference/Statements/function*">generator function</a>:</p>

<pre class="notranslate">function* generator() {
  yield 1;
  yield 2;
  yield 3;
}

const gen = generator(); // "Generator { }"

console.log(gen.next().value); // 1
console.log(generator().next().value); // 1
console.log(generator().next().value); // 1</pre>

<h2 id="Instance_methods">Instance methods</h2>

<dl>
 <dt>{{JSxRef("Generator.prototype.next()")}}</dt>
 <dd>Returns a value yielded by the {{JSxRef("Operators/yield", "yield")}} expression.</dd>
 <dt>{{JSxRef("Generator.prototype.return()")}}</dt>
 <dd>Returns the given value and finishes the generator.</dd>
 <dt>{{JSxRef("Generator.prototype.throw()")}}</dt>
 <dd>Throws an error to a generator (also finishes the generator, unless caught from within that generator).</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="An_infinite_iterator">An infinite iterator</h3>

<pre class="brush: js; notranslate">function* infinite() {
    let index = 0;

    while (true) {
        yield index++;
    }
}

const generator = infinite(); // "Generator { }"

console.log(generator.next().value); // 0
console.log(generator.next().value); // 1
console.log(generator.next().value); // 2
// ...</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
  </tr>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-generator-objects', 'Generator objects')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Generator")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{JSxRef("Statements/function*", "function*")}}</li>
 <li>{{JSxRef("Operators/function*", '<code>function*</code> expression', "", 1)}}</li>
 <li>{{JSxRef("GeneratorFunction")}}</li>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/The_Iterator_protocol">The Iterator protocol</a></li>
</ul>
